=begin
#Faxsuite RESTful API

#<p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |  

OpenAPI spec version: 4.0.0
Contact: support@fax-api.de
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.35
=end

module SwaggerClient
  class JobDetailsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # /jobs/{id}
    # Description: Obtain information of a specific job
    # @param id Identification number (UUID) of the job
    # @param [Hash] opts the optional parameters
    # @return [Job]
    def get_job(id, opts = {})
      data, _status_code, _headers = get_job_with_http_info(id, opts)
      data
    end

    # /jobs/{id}
    # Description: Obtain information of a specific job
    # @param id Identification number (UUID) of the job
    # @param [Hash] opts the optional parameters
    # @return [Array<(Job, Integer, Hash)>] Job data, response status code and response headers
    def get_job_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: JobDetailsApi.get_job ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling JobDetailsApi.get_job"
      end
      # resource path
      local_var_path = '/jobs/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Job' 

      auth_names = opts[:auth_names] || ['ApiAuthKey']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: JobDetailsApi#get_job\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /jobs/{id}/notifications
    # Description: To obtain a list of notifications to a specific job
    # @param id Identification number (UUID) of the job
    # @param [Hash] opts the optional parameters
    # @return [Notifications]
    def get_job_notifications(id, opts = {})
      data, _status_code, _headers = get_job_notifications_with_http_info(id, opts)
      data
    end

    # /jobs/{id}/notifications
    # Description: To obtain a list of notifications to a specific job
    # @param id Identification number (UUID) of the job
    # @param [Hash] opts the optional parameters
    # @return [Array<(Notifications, Integer, Hash)>] Notifications data, response status code and response headers
    def get_job_notifications_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: JobDetailsApi.get_job_notifications ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling JobDetailsApi.get_job_notifications"
      end
      # resource path
      local_var_path = '/jobs/{id}/notifications'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Notifications' 

      auth_names = opts[:auth_names] || ['ApiAuthKey']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: JobDetailsApi#get_job_notifications\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /jobs/{id}/preview
    # Description: To obtain the preview pdf document of a specific job
    # @param id Identification number (UUID) of the job
    # @param [Hash] opts the optional parameters
    # @return [Preview]
    def get_job_previews(id, opts = {})
      data, _status_code, _headers = get_job_previews_with_http_info(id, opts)
      data
    end

    # /jobs/{id}/preview
    # Description: To obtain the preview pdf document of a specific job
    # @param id Identification number (UUID) of the job
    # @param [Hash] opts the optional parameters
    # @return [Array<(Preview, Integer, Hash)>] Preview data, response status code and response headers
    def get_job_previews_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: JobDetailsApi.get_job_previews ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling JobDetailsApi.get_job_previews"
      end
      # resource path
      local_var_path = '/jobs/{id}/preview'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Preview' 

      auth_names = opts[:auth_names] || ['ApiAuthKey']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: JobDetailsApi#get_job_previews\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /jobs/{id}/recipients
    # Description: Resource to obtain a list of recipients to a specific job
    # @param id Identification number (UUID) of the job
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :object_limit Query parameter to change de default limitation of objects in the result data array (default to 100)
    # @option opts [Integer] :object_offset Query parameter to change de default offset of objects in the result data array (default to 0)
    # @option opts [String] :filter_fax_number Query parameter to fetch recipients after his fax number
    # @option opts [String] :filter_fax_number_norm Query parameter to fetch recipients after his normed fax number
    # @option opts [String] :filter_recipient_reference Query parameter to fetch recipients after his recipient reference
    # @option opts [String] :filter_international_dialing_code Query parameter to fetch recipients after his international dialing code
    # @option opts [String] :filter_result_code Query parameter to fetch recipients after his result code
    # @option opts [String] :filter_result_text Query parameter to fetch recipients after his result text
    # @option opts [String] :sort_field Available sort options for the result data array.
    # @option opts [String] :sort_order Describes the order for used sort fields (default to asc)
    # @return [JobRecipients]
    def get_job_recipients(id, opts = {})
      data, _status_code, _headers = get_job_recipients_with_http_info(id, opts)
      data
    end

    # /jobs/{id}/recipients
    # Description: Resource to obtain a list of recipients to a specific job
    # @param id Identification number (UUID) of the job
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :object_limit Query parameter to change de default limitation of objects in the result data array
    # @option opts [Integer] :object_offset Query parameter to change de default offset of objects in the result data array
    # @option opts [String] :filter_fax_number Query parameter to fetch recipients after his fax number
    # @option opts [String] :filter_fax_number_norm Query parameter to fetch recipients after his normed fax number
    # @option opts [String] :filter_recipient_reference Query parameter to fetch recipients after his recipient reference
    # @option opts [String] :filter_international_dialing_code Query parameter to fetch recipients after his international dialing code
    # @option opts [String] :filter_result_code Query parameter to fetch recipients after his result code
    # @option opts [String] :filter_result_text Query parameter to fetch recipients after his result text
    # @option opts [String] :sort_field Available sort options for the result data array.
    # @option opts [String] :sort_order Describes the order for used sort fields
    # @return [Array<(JobRecipients, Integer, Hash)>] JobRecipients data, response status code and response headers
    def get_job_recipients_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: JobDetailsApi.get_job_recipients ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling JobDetailsApi.get_job_recipients"
      end
      if @api_client.config.client_side_validation && opts[:'sort_field'] && !['faxNumber', 'faxNumberNorm', 'internationalDialingCode', 'recipientReference', 'fareZone', 'senderTime'].include?(opts[:'sort_field'])
        fail ArgumentError, 'invalid value for "sort_field", must be one of faxNumber, faxNumberNorm, internationalDialingCode, recipientReference, fareZone, senderTime'
      end
      if @api_client.config.client_side_validation && opts[:'sort_order'] && !['asc', 'desc'].include?(opts[:'sort_order'])
        fail ArgumentError, 'invalid value for "sort_order", must be one of asc, desc'
      end
      # resource path
      local_var_path = '/jobs/{id}/recipients'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'objectLimit'] = opts[:'object_limit'] if !opts[:'object_limit'].nil?
      query_params[:'objectOffset'] = opts[:'object_offset'] if !opts[:'object_offset'].nil?
      query_params[:'filterFaxNumber'] = opts[:'filter_fax_number'] if !opts[:'filter_fax_number'].nil?
      query_params[:'filterFaxNumberNorm'] = opts[:'filter_fax_number_norm'] if !opts[:'filter_fax_number_norm'].nil?
      query_params[:'filterRecipientReference'] = opts[:'filter_recipient_reference'] if !opts[:'filter_recipient_reference'].nil?
      query_params[:'filterInternationalDialingCode'] = opts[:'filter_international_dialing_code'] if !opts[:'filter_international_dialing_code'].nil?
      query_params[:'filterResultCode'] = opts[:'filter_result_code'] if !opts[:'filter_result_code'].nil?
      query_params[:'filterResultText'] = opts[:'filter_result_text'] if !opts[:'filter_result_text'].nil?
      query_params[:'sortField'] = opts[:'sort_field'] if !opts[:'sort_field'].nil?
      query_params[:'sortOrder'] = opts[:'sort_order'] if !opts[:'sort_order'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'JobRecipients' 

      auth_names = opts[:auth_names] || ['ApiAuthKey']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: JobDetailsApi#get_job_recipients\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /jobs/{id}/templates
    # Description: To obtain a list of template documents to a specific job
    # @param id Identification number (UUID) of the job
    # @param [Hash] opts the optional parameters
    # @return [Templates]
    def get_job_templates(id, opts = {})
      data, _status_code, _headers = get_job_templates_with_http_info(id, opts)
      data
    end

    # /jobs/{id}/templates
    # Description: To obtain a list of template documents to a specific job
    # @param id Identification number (UUID) of the job
    # @param [Hash] opts the optional parameters
    # @return [Array<(Templates, Integer, Hash)>] Templates data, response status code and response headers
    def get_job_templates_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: JobDetailsApi.get_job_templates ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling JobDetailsApi.get_job_templates"
      end
      # resource path
      local_var_path = '/jobs/{id}/templates'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Templates' 

      auth_names = opts[:auth_names] || ['ApiAuthKey']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: JobDetailsApi#get_job_templates\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /jobs/{id}
    # Description: Control the transmission of the specific job
    # @param body Describes the required request body to perform an action on the fax job
    # @param id Identification number (UUID) of the job
    # @param [Hash] opts the optional parameters
    # @return [Job]
    def put_job(body, id, opts = {})
      data, _status_code, _headers = put_job_with_http_info(body, id, opts)
      data
    end

    # /jobs/{id}
    # Description: Control the transmission of the specific job
    # @param body Describes the required request body to perform an action on the fax job
    # @param id Identification number (UUID) of the job
    # @param [Hash] opts the optional parameters
    # @return [Array<(Job, Integer, Hash)>] Job data, response status code and response headers
    def put_job_with_http_info(body, id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: JobDetailsApi.put_job ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling JobDetailsApi.put_job"
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling JobDetailsApi.put_job"
      end
      # resource path
      local_var_path = '/jobs/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      return_type = opts[:return_type] || 'Job' 

      auth_names = opts[:auth_names] || ['ApiAuthKey']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: JobDetailsApi#put_job\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
